SystemOrganization addCategory: #'DBus-Core'!

!Integer methodsFor: '*DBus-Core' stamp: 'bf 3/28/2008 18:03'!
dbusType
	"This is too convenient to omit, even though it's technically wrong ..."
	^DBusArgument int32! !

Object subclass: #DBusArgument
	instanceVariableNames: 'value type signature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBus-Core'!

!DBusArgument commentStamp: 'bf 7/16/2007 16:53' prior: 0!
This class is known to the DBus plugin. You must not change the order of instance variables.

I store arguments from a DBusMessage object. My argument can be another instance of me or supported Smalltalk objects like SmallInteger or Array. The signature says which dbus type the argument is. The type can be different from the squeak type. In case of integer ( int or uint ) be aware of number overflows. For every possible dbus type a class selector exist which create a new instance of me with an argument an the correct type signature. Some objects understand #asDBusArgument so for example a String answers direcly an instance of me. 

THIS CLASS NEEDS TO BE REFACTORED into type-specific subclasses to get rid of all the type-based cases. We'll need one class for basic types and one for each container type.!

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:34'!
array
	^ $a! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:34'!
array: arg
	^ self value: arg type: self array
	
	
! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'jaf 5/26/2007 22:51'!
array: arg signature: s
	^ self value: arg signature: s
	
	
! !

!DBusArgument class methodsFor: 'types' stamp: 'bf 3/27/2008 14:36'!
boolean
	^ $b! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 3/27/2008 14:36'!
boolean: arg
	^ self value: arg type: self boolean
	
	
! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:35'!
byte
	^ $y! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:35'!
byte: arg
	^ self value: arg type: self byte.! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:34'!
dictEntry
	^ $e! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:35'!
dictEntry: arg
	^ self value: arg type: self dictEntry
	
	
! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/31/2007 19:04'!
dictEntry: arg signature: sig
	^ self value: arg signature: sig
	
! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:38'!
double
	^ $d! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:35'!
double: arg
	^ self value: arg type: self double.! !

!DBusArgument class methodsFor: 'utilities' stamp: 'bf 2/29/2008 10:55'!
fullNameOfSignature: aSignature
	"Answer a capitalized fully recursive name for this signature"
	| entry |
	^String streamContents: [:stream |
		self signaturesIn: aSignature do: [:sig |
			stream nextPutAll: (sig first  caseOf: {
				[$a] ->  ['ArrayOf', (self fullNameOfSignature: sig allButFirst)].
				[${] -> [entry := self splitSignature: sig allButFirst allButLast.
					'DictEntryMapping', (self fullNameOfSignature: entry first),
					'To',  (self fullNameOfSignature: entry second)].
				[$(] -> [String streamContents: [:s |
					s nextPutAll:  'StructWith'.
					(self splitSignature: sig allButFirst allButLast)
						do: [:each | s nextPutAll: (self fullNameOfSignature: each)]
						separatedBy: [s nextPutAll: 'And']]]
				}
				otherwise: [(self nameOfType: sig first) capitalized])]]

"self fullNameOfSignature: 'a{s(six)}'"! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:36'!
int16
	^ $n! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:35'!
int16: arg
	^ self value: arg type: self int16.! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:37'!
int32
	^ $i! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:35'!
int32: arg
	^ self value: arg type: self int32.! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:37'!
int64
	^ $x! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:35'!
int64: arg
	^ self value: arg type: self int64.! !

!DBusArgument class methodsFor: 'utilities' stamp: 'bf 3/27/2008 16:16'!
nameOfSignature: aSignature
	"Answer a capitalized readable name for this signature, including one level of contained types"
	| entry |
	^String streamContents: [:stream |
		self signaturesIn: aSignature do: [:sig |
			stream nextPutAll: (sig first caseOf: {
				[$a] ->  [
					sig second caseOf: {
						[${] -> ['Dictionary'].
						[$a] -> [sig third = ${
							ifTrue: ['ArrayOfDictionaries']
							ifFalse: ['ArrayOfArrays']]
					} otherwise: ['ArrayOf', (self nameOfType: sig second) capitalized, 's']].
				[${] -> [entry := self splitSignature: sig allButFirst allButLast.
					'DictEntryMapping', (self nameOfType: entry first first) capitalized,
					'To',  (self nameOfType: entry second first) capitalized].
				[$(] -> [String streamContents: [:s |
					s nextPutAll:  'StructWith'.
					(self splitSignature: sig allButFirst allButLast)
						do: [:each | s nextPutAll: (self nameOfType: each) capitalized]
						separatedBy: [s nextPutAll: 'And']]]
				}
				otherwise: [(self nameOfType: sig first) capitalized])]]

"self nameOfSignature: 'a{s(six)}'"! !

!DBusArgument class methodsFor: 'utilities' stamp: 'bf 2/27/2008 17:27'!
nameOfType: aType
	self typesAndNames
		pairsDo: [:key :value | aType = key ifTrue: [^value]].
	^nil! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:38'!
objectPath
	^ $o! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:36'!
objectPath: arg
	^ self value: arg type: self objectPath! !

!DBusArgument class methodsFor: 'utilities' stamp: 'bf 2/26/2008 16:26'!
readSignature: aStream
	"read one (complex) type from a signature stream, answer its signature"
	| start |
	start := aStream position.
	self readType: aStream.
	^aStream contents copyFrom: start+1 to: aStream position! !

!DBusArgument class methodsFor: 'utilities' stamp: 'bf 2/27/2008 17:27'!
readType: aStream
	"skip one (complex) type from a signature stream, answer its type code"
	| type |
	type := aStream next.
	type caseOf: {
			[$a] -> [self readType: aStream].
			[$(] -> [[aStream peek = $)] whileFalse: [self readType: aStream].
				aStream next = $) ifFalse: [self error: 'malformed signature']].
			[${] -> [self readType: aStream; readType: aStream.
				aStream next = $} ifFalse: [self error: 'malformed signature']].
		}
		otherwise: [].
	^type! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:39'!
signature
	^ $g! !

!DBusArgument class methodsFor: 'utilities' stamp: 'bf 2/27/2008 17:25'!
signaturesIn: aString do: aBlock
	"Evaluate aBlock with all (possibly complex) signatures in aString"
	| in |
	in := aString readStream.
	[in atEnd] whileFalse: [
		aBlock value: (self readSignature: in)].
! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:36'!
signature: arg
	^ self value: arg type: self signature! !

!DBusArgument class methodsFor: 'utilities' stamp: 'bf 2/27/2008 17:26'!
splitSignature: aString
	"Answer an array of the signatures in aString"
	^Array streamContents: [:out |
		self signaturesIn: aString do: [:sig | 
			out nextPut: sig]].

"(self splitSignature: 'ass') = #('as' 's')"! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:38'!
string
	^ $s! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:36'!
string: arg
	^ self value: arg type: self string! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:34'!
struct
	^ $r! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:36'!
struct: arg
	^ self value: arg type: self struct
	
	
! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/31/2007 19:06'!
struct: arg signature: sig
	^ self value: arg signature: sig
	
	
! !

!DBusArgument class methodsFor: 'utilities' stamp: 'bf 3/27/2008 14:35'!
typesAndNames
	^#(
		$a array
		$b boolean
		$y byte
		$e dictEntry
		${ dictEntry
		$d double
		$n int16
		$i int32
		$x int64
		$o objectPath
		$g signature
		$s string
		$r struct
		$( struct
		$q uint16
		$u uint32
		$t uint64
		$v variant)! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:36'!
uint16
	^ $q! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:36'!
uint16: arg
	^ self value: arg type: self uint16.! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:37'!
uint32
	^ $u! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:36'!
uint32: arg
	^ self value: arg type: self uint32.! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:37'!
uint64
	^ $t! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:36'!
uint64: arg
	^ self value: arg type: self uint64.! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 6/18/2008 16:45'!
value: value signature: s
	| arg |
	arg := self value: value type: (
		s first caseOf: {
			[${] -> [self dictEntry].
			[$(] -> [self struct].
		} otherwise: [s first]).
	arg signature: s.
	^arg	
	

! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 6/18/2008 16:47'!
value: value type: t
	^ self new value: value type: t
	! !

!DBusArgument class methodsFor: 'types' stamp: 'jf 5/21/2007 15:34'!
variant
	^ $v! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'bf 5/25/2007 20:36'!
variant: arg
	^ self value: arg type: self variant.! !

!DBusArgument class methodsFor: 'instance creation' stamp: 'jaf 5/26/2007 22:52'!
variant: arg signature: s
	^ self value: arg signature: s! !

!DBusArgument methodsFor: 'accessing' stamp: 'jf 5/21/2007 15:25'!
asDBusArgument
	^ self! !

!DBusArgument methodsFor: 'accessing' stamp: 'bf 11/16/2007 20:06'!
containedDBusArgumentsDo: aBlock
	"XXX refactor into subclasses"
	type caseOf: {
		[DBusArgument struct]
			-> [signature
					ifNil: [value do: [:each | aBlock value: each asDBusArgument]]
					ifNotNil: [
						"XXX iterating over chars will fail for contained multi-character signatures"
						value with: self containedSignature do: [:v :c |
							('a({' includes: c) ifTrue: [^self error: 'containers in structs not implemented yet'].
							aBlock value: (DBusArgument value: v type: c)]]].
		[DBusArgument dictEntry]
			-> [signature
					ifNil: [aBlock value: value key asDBusArgument.
						aBlock value: value value asDBusArgument]
					ifNotNil: [
						"XXX wrong if key has a multi-character signature"
						('a({' includes: signature second) ifTrue: [^self error: 'containers as dict keys not implemented yet'].
						aBlock value: (DBusArgument
							value: value key
							signature: (signature copyFrom: 2 to: 2)).
						aBlock value: (DBusArgument
							value: value value
							signature: (signature copyFrom: 3 to: signature size - 1))]].
		[DBusArgument array]
			-> ["this is a bit of a hack - we want to iterate over associations if we contain a dict. Fortunately this works for Arrays too ..."
				signature
					ifNil: [value associationsDo: [:each | aBlock value: each asDBusArgument]]
					ifNotNil: [
						| sig |
						sig := self containedSignature.
						value associationsDo: [:each | aBlock value: (DBusArgument value: each signature: sig)]]].
		[DBusArgument variant]
			-> [aBlock value: value asDBusArgument]
	}
		otherwise:  [self error: 'only container types may be iterated over'].
! !

!DBusArgument methodsFor: 'accessing' stamp: 'jaf 5/31/2007 22:19'!
containedSignature
	^ String streamContents: [:stream| self printContainedSignatureOn: stream]! !

!DBusArgument methodsFor: 'accessing' stamp: 'bf 5/25/2007 20:09'!
dbusType
	^type! !

!DBusArgument methodsFor: 'accessing' stamp: 'bf 3/28/2008 16:06'!
fromDBusArgument
	"XXX refactor into subclasses"

	self isBasicType ifTrue: [^value].
	^type caseOf: {
		[DBusArgument struct]
			-> [value collect: [:ea | ea fromDBusArgument]].
		[DBusArgument dictEntry]
			-> [value key fromDBusArgument -> value value fromDBusArgument].
		[DBusArgument array]
			-> [| arr | 
				signature = 'ay' ifTrue: [^value].
				arr := value collect: [:ea | ea fromDBusArgument].
				self containedSignature first =${
					ifTrue: [arr as: Dictionary]
					ifFalse: [arr]].
		[DBusArgument variant]
			-> [value fromDBusArgument]
	}				   
			! !

!DBusArgument methodsFor: 'accessing' stamp: 'jaf 5/26/2007 21:39'!
isBasicType
	^('avre' includes: type) not! !

!DBusArgument methodsFor: 'printing' stamp: 'bf 6/19/2008 20:16'!
printContainedSignatureOn: aStream
	"XXX refactor into subclasses"

	type = DBusArgument variant
		ifTrue: [
			"stored signature would be 'v' so ignore, must use actual signature"
			^value asDBusArgument printSignatureOn: aStream].

	signature ifNotNil: [
		^('{(' includes: signature first)
			ifTrue: [aStream next: signature size - 2 putAll: signature startingAt: 2]
			ifFalse: [aStream next: signature size - 1 putAll: signature startingAt: 2]].

	type caseOf: {
		[DBusArgument struct]
			-> [value do: [:ea| ea asDBusArgument printSignatureOn: aStream]].
		[DBusArgument dictEntry]
			-> [value key asDBusArgument printSignatureOn: aStream.
				value value asDBusArgument printSignatureOn: aStream].
		[DBusArgument array]
			-> [value class == ByteArray
				ifTrue: [aStream nextPut: DBusArgument byte]
				ifFalse: [value first asDBusArgument printSignatureOn: aStream]].
	}					   

			! !

!DBusArgument methodsFor: 'printing' stamp: 'jaf 5/27/2007 00:00'!
printOn: aStream	

	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	
	self printSignatureOn: aStream.
	
	aStream nextPut: $);
			nextPut: $[.
	value printOn: aStream.
	aStream nextPut: $]! !

!DBusArgument methodsFor: 'printing' stamp: 'bf 7/16/2007 17:17'!
printSignatureOn: aStream	
	"XXX refactor into subclasses"

	signature ifNotNil: [ ^ aStream nextPutAll: signature].
	self isBasicType ifTrue: [^aStream nextPut: type].
	type caseOf: {
		[DBusArgument struct]
			-> [aStream nextPut: $(.
				self printContainedSignatureOn: aStream.
				aStream print: $)].
		[DBusArgument dictEntry]
			-> [aStream nextPut: ${.
				self printContainedSignatureOn: aStream.
				aStream nextPut: $}].
		[DBusArgument array]
			-> [aStream nextPut: $a.
				self printContainedSignatureOn: aStream].
		[DBusArgument variant]
			-> [aStream nextPut: $v]
	}				   

			! !

!DBusArgument methodsFor: 'accessing' stamp: 'jaf 5/31/2007 22:18'!
signature
	^ String streamContents: [:stream| self printSignatureOn: stream]
	
		! !

!DBusArgument methodsFor: 'accessing' stamp: 'bf 5/25/2007 21:12'!
signature: aString
	signature := aString! !

!DBusArgument methodsFor: 'accessing' stamp: 'bf 5/25/2007 21:11'!
type
	^type! !

!DBusArgument methodsFor: 'accessing' stamp: 'bf 5/25/2007 18:19'!
value
	^value ! !

!DBusArgument methodsFor: 'initialize' stamp: 'bf 6/18/2008 16:44'!
value: anObject type: aChar
	type := aChar.
	value := anObject dbusCoerceTo: type! !

Object subclass: #DBusConnection
	instanceVariableNames: 'connectionIndex semaIndex readSemaphore'
	classVariableNames: 'SystemBus SessionBus Readers Writers'
	poolDictionaries: ''
	category: 'DBus-Core'!

!DBusConnection commentStamp: '<historical>' prior: 0!
I represent a connection to the DBus (see http://dbus.freedesktop.org/).

connectionIndex: 0 for session bus, 1 for system bus
semaIndex: index of the read semaphore in the externalObjects array

This class is known to the DBus plugin. The connectionIndex and semaIndex must be the first instance variables in the class.

The plugin automatically connects to the DBus when a primitive of me is called.!

!DBusConnection class methodsFor: 'private' stamp: 'bf 3/7/2008 16:48'!
allBussesDo: aBlock
	SessionBus ifNotNilDo: [:bus | aBlock value: bus].
	SystemBus ifNotNilDo: [:bus | aBlock value: bus].! !

!DBusConnection class methodsFor: 'constants' stamp: 'jaf 5/13/2007 20:07'!
complete
	"incoming queue is empty"
	^ 1! !

!DBusConnection class methodsFor: 'constants' stamp: 'jaf 5/15/2007 11:00'!
dataRemains
	"indicates that the message queue may contain messages"
	^ 0! !

!DBusConnection class methodsFor: 'examples' stamp: 'bf 6/19/2008 01:09'!
example
	"this example show the general low level usage of the dbus plugin"
	" to start call
		DBusConnection example
	  
	to stop the process call
		DBusConnection new sendMessage: (DBusMessage testMethodCall member: 'setprocessstatus')
	
	send a signal	
		DBusConnection new sendMessage: (DBusMessage testSignal)
	"
	
	| connection msg process appName |
	
	appName := 'org.squeak.dbus.example'.
	
	"connect tot session bus"
	connection := DBusConnection sessionBus.

	"request unique name for squeak example at dbus"
	connection registerName: appName.	
		
	"register a match rule to receive a certain signal"
	connection addMatch: #(
		type 'signal'
		interface 'org.squeak.dbus.testinterface').
	
	process := true.
	
	[
		Transcript show: String cr, '--- Begin dbus queue processing ---'; cr.
		 
		"step the connection"	
		[process] whileTrue: [
			[connection dataRemains] whileTrue: [
				"read messages"
				msg := connection popMessage.
				msg ifNotNil: [Transcript show: 'Received message: ', msg asString; cr.
							 "process message"
							  msg isMethodCall 
								ifTrue: [ ((msg member = 'setprocessstatus') and: [msg hasArguments]) 
											ifTrue: [ process := (msg arguments at: 1) value ]
											ifFalse: [ "answer an error"
													connection sendMessage: (DBusMessageError unknownMethod: msg)] ]
							].
				].
			process ifTrue: [connection readSemaphore wait].
		].
		
		"release name"
		connection releaseName: appName.
		
		"close connection"
		connection close.

		Transcript show: '--- end ---' , String cr.  
	] forkAt: Processor userBackgroundPriority.

	" send a quit message
	
	DBusConnection new sendMessage: 
		((DBusMessageMethodCall destination: 'org.squeak.dbus.example' 
								path: '/org/squeak/dbus/example' 
								interface: 'org.squeak.dbus.test' 
								member: 'setprocessstatus' )
								addArgument: (DBusArgument bool: false);	
								reply: false)
	"
! !

!DBusConnection class methodsFor: 'private' stamp: 'bf 6/20/2008 00:22'!
getBus: connIndex from: oldBus
	"automatically migrate to a more specific subclass of me"
	| sema |
	(oldBus isKindOf: self) ifTrue: [^oldBus].
	oldBus ifNotNil: [
		sema := oldBus readSemaphore.
		oldBus destroy].
	sema ifNil: [sema := Semaphore new].
	^self new
		setConnectionIndex: connIndex readSemaphore: sema;
		startUp;
		yourself! !

!DBusConnection class methodsFor: 'class initialization' stamp: 'bf 3/27/2008 14:37'!
initialize
	"self initialize"

	"start up before AutoStart".
	Smalltalk addToStartUpList: self after: FileDirectory.

	Readers := {
		$b->#argumentReadBoolean.
		$d->#argumentReadDouble.
		$s->#argumentReadString.
		$a->#argumentReadArray.
		$e->#argumentReadDictEntry.
		$r->#argumentReadStruct.
		$o->#argumentReadObjectPath.
		$v->#argumentReadVariant.
		$y->#argumentReadByte.
		$n->#argumentReadInt16.
		$q->#argumentReadUInt16.
		$i->#argumentReadInt32.
		$u->#argumentReadUInt32.
		$x->#argumentReadInt64.
		$t->#argumentReadUInt64.
		$g->#argumentReadSignature.
	} as: Dictionary.
	
	Writers := {
		$b->#argumentWriteBasicArgument:.
		$i->#argumentWriteBasicArgument:.
		$d->#argumentWriteBasicArgument:.
		$s->#argumentWriteBasicArgument:.
		$y->#argumentWriteBasicArgument:.
		$n->#argumentWriteBasicArgument:.
		$q->#argumentWriteBasicArgument:.
		$u->#argumentWriteBasicArgument:.
		$x->#argumentWriteBasicArgument:.
		$t->#argumentWriteBasicArgument:.
		$o->#argumentWriteBasicArgument:.
		$g->#argumentWriteBasicArgument:.
		$a->#argumentWriteArray:.
		$e->#argumentWriteDictEntry:.
		$r->#argumentWriteStruct:.
		$v->#argumentWriteVariant:.
	} as: Dictionary.
	
! !

!DBusConnection class methodsFor: 'constants' stamp: 'jaf 5/15/2007 11:02'!
needMemory
	"indicates that there could be data, but whitout more memory it is not sure"
	^ 2! !

!DBusConnection class methodsFor: 'instance creation' stamp: 'bf 3/7/2008 16:38'!
sessionBus
	"automatically migrate to a more specific subclass of me"
	^SessionBus := self getBus: 0 from: SessionBus! !

!DBusConnection class methodsFor: 'start up' stamp: 'bf 5/1/2008 15:58'!
startUp: resuming
	resuming ifFalse: [^self].

	self allBussesDo: [:each| each startUp]! !

!DBusConnection class methodsFor: 'instance creation' stamp: 'bf 3/7/2008 16:40'!
systemBus
	"automatically migrate to a more specific subclass of me"
	^SystemBus := self getBus: 1 from: SystemBus! !

!DBusConnection class methodsFor: 'class initialization' stamp: 'bf 3/7/2008 16:49'!
unload
	Smalltalk removeFromStartUpList: self.
	self allBussesDo: [:each | each destroy]! !

!DBusConnection methodsFor: 'dbus-matches' stamp: 'bf 11/28/2007 15:10'!
addMatch: anArray
	"add a match. Keys include type, sender, interface, member, path, destination, arg0, arg1 etc. Only string args can be matched.
	E.g. #(type 'signal'
		sender 'org.freedesktop.DBus'
		interface 'org.freedesktop.DBus'
		member 'Foo'
		path '/bar/foo'
		destination ':452345.34')
	"

	^ self primAddMatch: (self matchString: anArray)! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'bf 5/8/2008 17:17'!
argumentReadArray
	"returns an array"	
	| arg sig array |
	sig := self primIteratorSignature. 

	sig = 'ay' ifTrue: [
		^DBusArgument array: (
			ByteArray streamContents: [:strm |
				self primPushIterator.
				[	arg := [self primArgumentGetByte] ifError: [nil].
					"XXX earlier plugins answer signed bytes"
					arg ifNotNil: [strm nextPut: (arg bitAnd: 16rFF)].
					self nextIterator
				] whileTrue.
				self popIterator])
			signature: sig].

	array := Array streamContents: [:strm |
		self primPushIterator.
		[	arg := self getArgument.
			arg ifNotNil: [strm nextPut: arg].
			self nextIterator
		] whileTrue.
		self popIterator].
	^ DBusArgument array: array signature: sig
	
! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'bf 3/27/2008 14:37'!
argumentReadBoolean

	^ DBusArgument boolean: self primArgumentGetBool! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'bf 3/27/2008 17:46'!
argumentReadByte
	"XXX earlier plugins answer signed bytes"
	^ DBusArgument byte: (self primArgumentGetByte bitAnd: 16rFF)! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'bf 5/31/2007 19:08'!
argumentReadDictEntry

	| sig key value |
	sig := self primIteratorSignature.
	self primPushIterator.
	key := self getArgument.
	self nextIterator.
	value := self getArgument.
	self popIterator.
	
	^DBusArgument dictEntry: key->value signature: sig.
	! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:47'!
argumentReadDouble

	^ DBusArgument double: self primArgumentGetFloat! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:48'!
argumentReadInt16

	^ DBusArgument int16: self primArgumentGetInt16! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:48'!
argumentReadInt32

	^ DBusArgument int32: self primArgumentGetInt32! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:48'!
argumentReadInt64

	^ DBusArgument int64: self primArgumentGetInt64! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:49'!
argumentReadObjectPath

	^ DBusArgument objectPath: self primArgumentGetObjectPath! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:49'!
argumentReadSignature

	^ DBusArgument signature: self primArgumentGetSignature! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:49'!
argumentReadString

	^ DBusArgument string: self primArgumentGetString! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'bf 5/31/2007 19:06'!
argumentReadStruct
	"returns an struct"	
	| sig arr hasArg |
	sig := self primIteratorSignature.
	arr := OrderedCollection new.		
	
	self primPushIterator.	
	"read the members of the struct"			
	hasArg := true.	
	[hasArg] 
		whileTrue: [
			arr add: self getArgument.
			hasArg := self nextIterator.
		].
	self popIterator.
	^ DBusArgument struct: arr asArray signature: sig! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:49'!
argumentReadUInt16

	^ DBusArgument uint16: self primArgumentGetUInt16! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:50'!
argumentReadUInt32

	^ DBusArgument uint32: self primArgumentGetUInt32! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:50'!
argumentReadUInt64

	^ DBusArgument uint64: self primArgumentGetUInt64! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'jaf 5/26/2007 23:51'!
argumentReadVariant
	"returns a variant"	
	| variant sig |
	sig := self primIteratorSignature. 
	self primPushIterator.	
	variant := self getArgument.
	self popIterator.
	^DBusArgument variant: variant signature: sig! !

!DBusConnection methodsFor: 'arguments-write' stamp: 'bf 6/19/2008 20:33'!
argumentWriteArray: arg
	| sig |
	sig := arg containedSignature.
	(self openContainerOfType: arg dbusType containedSignature: sig) ifTrue: [
		sig = 'y'
			ifTrue: [arg value do: [:each | self primAppendBasicArgument: each ofType: 121]]
			ifFalse: [arg containedDBusArgumentsDo: [:each| self writeArgument: each]].
		self primCloseContainer ]. 
! !

!DBusConnection methodsFor: 'arguments-write' stamp: 'jaf 5/26/2007 21:15'!
argumentWriteBasicArgument: arg

	self primAppendBasicArgument: arg value ofType: arg type asInteger

! !

!DBusConnection methodsFor: 'arguments-write' stamp: 'bf 7/16/2007 17:11'!
argumentWriteDictEntry: arg
	(self openContainerOfType: arg dbusType containedSignature: arg containedSignature) ifTrue: [
		arg containedDBusArgumentsDo: [:each| self writeArgument: each].
		self primCloseContainer]. 
! !

!DBusConnection methodsFor: 'arguments-write' stamp: 'bf 7/16/2007 17:10'!
argumentWriteStruct: arg
	(self openContainerOfType: arg dbusType containedSignature: arg containedSignature) ifTrue: [
		arg containedDBusArgumentsDo: [:each| self writeArgument: each].
		self primCloseContainer]. 
	

! !

!DBusConnection methodsFor: 'arguments-write' stamp: 'bf 7/16/2007 17:11'!
argumentWriteVariant: arg
	(self openContainerOfType: arg dbusType containedSignature: arg containedSignature) ifTrue: [
		arg containedDBusArgumentsDo: [:each| self writeArgument: each].
		self primCloseContainer]. 
! !

!DBusConnection methodsFor: 'initialize-release' stamp: 'bf 3/5/2008 16:27'!
close
	"close the connection. The plugin will automatically reopen it on demand"
	self primClose.
! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 5/13/2007 19:38'!
dataRemains
  ^ ( self primDispatchStatus = DBusConnection dataRemains )
	! !

!DBusConnection methodsFor: 'initialize-release' stamp: 'bf 3/7/2008 16:34'!
destroy
	self setConnectionIndex: nil readSemaphore: nil! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 5/13/2007 18:54'!
dispatchStatus

	^ self primDispatchStatus ! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 4/26/2007 13:04'!
errorName
	^ self primMessageGetErrorName! !

!DBusConnection methodsFor: 'private' stamp: 'jaf 5/27/2007 00:34'!
getArgument

	| type |
	type := self getArgumentType.
	
	"a hack for dbus_type_invalid"
	(type asInteger = 0) ifTrue: [^ nil].
	
	Readers at: type ifPresent: [:sel | ^ self perform: sel].
	
	self error: 'Found no selector for argument type: ', type .! !

!DBusConnection methodsFor: 'arguments-read' stamp: 'bf 5/14/2007 20:18'!
getArgumentType

	^ self primArgumentGetType ifNotNilDo: [:byte | byte asCharacter]! !

!DBusConnection methodsFor: 'private' stamp: 'bf 11/28/2007 15:59'!
matchString: anArray
	"Construct a dbus match string from anArray"

	^String streamContents: [:strm |
		 anArray pairsDo: [:key :value |
			strm position > 0 ifTrue: [strm nextPut: $,].
			strm nextPutAll: key;
				nextPut: $=;
				print: value squeakToUtf8]]! !

!DBusConnection methodsFor: 'accessing' stamp: 'jf 5/21/2007 15:51'!
messageHasArguments	
	^ self primMessageHasArguments
		
	! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 4/26/2007 13:01'!
messageInterface
	^ self primMessageGetInterface! !

!DBusConnection methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:23'!
messageMember
	^ self primMessageGetMember! !

!DBusConnection methodsFor: 'accessing' stamp: 'bf 3/5/2008 17:28'!
messageNoReply
		
	^ self primMessageGetNoReply! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 4/26/2007 13:00'!
messagePath
	^ self primMessageGetPath! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 5/3/2007 14:05'!
messageReplySerial
	^ self primMessageReplySerial! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 4/26/2007 13:00'!
messageSender
	^ self primMessageGetSender! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 4/27/2007 10:02'!
messageSerial
	^ self primMessageSerial! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 4/26/2007 13:01'!
messageSignature
	^ self primMessageGetSignature! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 4/26/2007 14:10'!
nextIterator

	^ self primNextIterator! !

!DBusConnection methodsFor: 'private' stamp: 'jaf 5/26/2007 21:16'!
openContainerOfType: t containedSignature: s

	^ self primOpenContainer: t asInteger containedSignature: s! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 4/26/2007 13:47'!
popIterator
	^ self primPopIterator! !

!DBusConnection methodsFor: 'messages' stamp: 'bf 6/19/2008 01:55'!
popMessage
	""

	"first read dbus connection"
	
	| type msg |
	type := self primPopMessage.
	
	"if there is no new message reveived return"
	(type = 0) ifTrue:[^nil]. 
	
	"create new message"
	msg := DBusMessage typeCode: type.
	msg ifNil:[^nil].
	
	"read message from the bus"
	msg readFromConnection: self.

	^msg! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:05'!
primAddMatch: rule 
	"adds a match rule to recive signals"
		
	<primitive: 'primitiveDBusAddMatch' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:06'!
primAppendBasicArgument: arg ofType: t
	"appends a basic type argument like int16 or uint32 of type t to the external message"	
	<primitive: 'primitiveDBusAppendBasicArgument' module: 'DBusPlugin'>
	
	^ self primitiveFailed
	
	! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 4/23/2007 18:44'!
primArgumentGetBool
		
	<primitive: 'primitiveDBusArgumentGetBool' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jf 5/23/2007 19:05'!
primArgumentGetByte
		
	<primitive: 'primitiveDBusArgumentGetByte' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 4/20/2007 11:24'!
primArgumentGetFloat
		
	<primitive: 'primitiveDBusArgumentGetDouble' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jf 5/23/2007 19:05'!
primArgumentGetInt16
		
	<primitive: 'primitiveDBusArgumentGetInt16' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jf 5/23/2007 19:06'!
primArgumentGetInt32
		
	<primitive: 'primitiveDBusArgumentGetInt32' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jf 5/23/2007 19:06'!
primArgumentGetInt64
		
	<primitive: 'primitiveDBusArgumentGetInt64' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'bf 5/14/2007 20:53'!
primArgumentGetObjectPath
		
	<primitive: 'primitiveDBusArgumentGetObjectPath' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jf 5/23/2007 19:12'!
primArgumentGetSignature
		
	<primitive: 'primitiveDBusArgumentGetSignature' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 4/20/2007 10:34'!
primArgumentGetString
		
	<primitive: 'primitiveDBusArgumentGetString' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 4/26/2007 11:12'!
primArgumentGetType
		
	<primitive: 'primitiveDBusArgumentGetType' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jf 5/23/2007 19:06'!
primArgumentGetUInt16
		
	<primitive: 'primitiveDBusArgumentGetUInt16' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jf 5/23/2007 19:06'!
primArgumentGetUInt32
		
	<primitive: 'primitiveDBusArgumentGetUInt32' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jf 5/23/2007 19:06'!
primArgumentGetUInt64
		
	<primitive: 'primitiveDBusArgumentGetUInt64' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:07'!
primClose
	"close the connection of the receiver and destroy the singleton in the plugin"	
	<primitive: 'primitiveDBusConnectionClose' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:08'!
primCloseContainer
	"close an prevouisly opened container in the plugin"	
	<primitive: 'primitiveDBusIterCloseContainer' module: 'DBusPlugin'>
	
	^ self primitiveFailed
	
	! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:08'!
primCreateMessageFrom: msg
	"creates an external messages for the msg object"	
	<primitive: 'primitiveDBusCreateMessageFrom' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:09'!
primDispatchStatus
	"answer the process status of the receivers connection
	 0 data remains
	 1 complete
	 2 need memory"
		
	<primitive: 'primitiveDBusConnectionDispatchStatus' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'bf 7/16/2007 16:06'!
primInitializeWriteIterator
	"initializes an iterator for the externel messages to add arguments"	
	<primitive: 'primitiveDBusInitializeWriteIterator' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:10'!
primIteratorSignature
	"answer the signature of the currently active iterator"	
	<primitive: 'primitiveDBusIteratorSignature' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:11'!
primMessageGetDestination
	"answers the destination of the received message"	
	<primitive: 'primitiveDBusMessageGetDestination' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:11'!
primMessageGetErrorName
	"answers the name of the received error message"		
	<primitive: 'primitiveDBusMessageGetErrorName' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:11'!
primMessageGetInterface
	"answers the inteface of the received message"		
	<primitive: 'primitiveDBusMessageGetInterface' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:13'!
primMessageGetMember
	"answers the selector of the received message."		
	<primitive: 'primitiveDBusMessageGetMember' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:14'!
primMessageGetNoReply
	"answers true if the received message expects a reply"	
	<primitive: 'primitiveDBusMessageGetNoReply' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:14'!
primMessageGetPath
	"answers the path of the received message"		
	<primitive: 'primitiveDBusMessageGetPath' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:14'!
primMessageGetSender
	"answers the serial for the sender of the received message"		
	<primitive: 'primitiveDBusMessageGetSender' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:15'!
primMessageGetSignature
	"answers the signature of the received message"		
	<primitive: 'primitiveDBusMessageGetSignature' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:15'!
primMessageHasArguments
	"answers true if the received message has arguments to read"		
	<primitive: 'primitiveDBusMessageHasArguments' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:17'!
primMessageReplySerial
	"answers the serial that the received message is a reply to or 0 if none"	
	<primitive: 'primitiveDBusMessageGetReplySerial' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:17'!
primMessageSerial
	"answers the serial of the received message"	
	<primitive: 'primitiveDBusMessageGetSerial' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:19'!
primNextIterator
	"switches the current iterator to his next to read the next argument. it answers true if the current has a next iterator otherwise false"		
	<primitive: 'primitiveDBusNextIterator' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:23'!
primOpenContainer: t containedSignature: s
	"opens a new subcontainer in the plugin to write arrays, structs, variants or dictentries. If you want to open a container to write the elements of an array the containedSignature should be a string of the element signatures. To write an variant containedSignature should be the signature of the value of the variant. It can be nil on structs and dictentries"	
	<primitive: 'primitiveDBusIterOpenContainerContains' module: 'DBusPlugin'>	
	
	^ self primitiveFailed
	
	! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:24'!
primPopIterator
	"pops an interator from the iterator stack"
	<primitive: 'primitiveDBusPopMessageIterator' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:25'!
primPopMessage
	"answers and pops a received message from the message queue in the plugin"	
	<primitive: 'primitiveDBusConnectionPopMessage' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:25'!
primPushIterator
	"pushes an iterator to an iterator stack to read container type arguments"
	<primitive: 'primitiveDBusPushMessageIterator' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 4/27/2007 13:23'!
primRegisterName: name 
	"1 Service has become the primary owner of the requested name
	 2 Service could not become primary owner and has been placed in the queue
	 3 Service is already in the queue
	 4 Service is already the primary owner"
	
	<primitive: 'primitiveDBusRegisterName' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 4/27/2007 13:23'!
primReleaseName: name 
	"1 Service was released from the given name
	 2 Name does not exist on the bus
	 3 Service is not owner of the given name"
	
	<primitive: 'primitiveDBusReleaseName' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'jaf 5/27/2007 00:27'!
primRemoveMatch: rule 
	"removes a match rule for a signal"	
	<primitive: 'primitiveDBusRemoveMatch' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'primitives' stamp: 'bf 3/5/2008 18:00'!
primSendMessageTimeout: milliseconds
	"Send the previously created message and return the serial of the message. If timeout is 0, do not generate a timeout error. If timeout is -1, use a default timeout."	
	<primitive: 'primitiveDBusSendMessageTimeout' module: 'DBusPlugin'>
	
	^ self primitiveFailed! !

!DBusConnection methodsFor: 'printing' stamp: 'bf 3/5/2008 17:03'!
printOn: aStream
	aStream
		nextPutAll: self class name;
		nextPutAll: (connectionIndex caseOf: {
			[0] -> [' sessionBus'].
			[1] -> [' systemBus']
			} otherwise: ['(invalid)']).! !

!DBusConnection methodsFor: 'accessing' stamp: 'jaf 5/8/2007 20:42'!
readSemaphore
	^readSemaphore ! !

!DBusConnection methodsFor: 'dbus-names' stamp: 'bf 5/31/2007 17:24'!
registerName: name
	"1 Service has become the primary owner of the requested name
	 2 Service could not become primary owner and has been placed in the queue
	 3 Service is already in the queue
	 4 Service is already the primary owner"
	(#(1 4) includes: (self primRegisterName: name))
		ifFalse: [self error: 'DBus: Could not become primary owner of ', name]
	! !

!DBusConnection methodsFor: 'initialize-release' stamp: 'bf 6/20/2008 00:18'!
registerSemaphore
	(semaIndex notNil and: [(Smalltalk externalObjects at: semaIndex) == readSemaphore])
		ifTrue: [^self].
	semaIndex := readSemaphore ifNotNil: [Smalltalk registerExternalObject: readSemaphore]! !

!DBusConnection methodsFor: 'dbus-names' stamp: 'jaf 4/27/2007 13:23'!
releaseName: name
	self primReleaseName: name ! !

!DBusConnection methodsFor: 'dbus-matches' stamp: 'bf 11/28/2007 15:10'!
removeMatch: anArray
	"Remove a match added by addMatch:"

	^ self primRemoveMatch: (self matchString: anArray)! !

!DBusConnection methodsFor: 'messages' stamp: 'bf 3/5/2008 17:58'!
sendMessage: msg
	"send message with a (system-defined) default timeout"
	^self sendMessage: msg timeout: -1! !

!DBusConnection methodsFor: 'messages' stamp: 'bf 3/5/2008 17:59'!
sendMessage: msg timeout: timeoutMilliseconds

	"create a new external message"
	| serial |
	self primCreateMessageFrom: msg.
	
	"add arguments to the message"
	msg hasArguments ifTrue: [
		"initialize iterator"
		self primInitializeWriteIterator.
		msg arguments do: [:each| self writeArgument: each]].
	
	"finally send the message"
	serial := self primSendMessageTimeout: (msg reply
		ifTrue: [timeoutMilliseconds]
		ifFalse: [0]).
	msg serial: serial.
	^serial! !

!DBusConnection methodsFor: 'initialize-release' stamp: 'bf 3/7/2008 16:35'!
setConnectionIndex: aConnectionIndex readSemaphore: aSemaphore

	connectionIndex ifNotNil: [self close].
	connectionIndex := aConnectionIndex.
	self unregisterSemaphore.
	readSemaphore := aSemaphore.
	self registerSemaphore.
! !

!DBusConnection methodsFor: 'initialize-release' stamp: 'bf 5/1/2008 15:57'!
startUp
	self registerSemaphore.! !

!DBusConnection methodsFor: 'initialize-release' stamp: 'bf 3/7/2008 15:39'!
unregisterSemaphore
	semaIndex ifNotNil: [
		(Smalltalk externalObjects at: semaIndex) == readSemaphore
			ifTrue: [Smalltalk unregisterExternalObject: readSemaphore].
		semaIndex := nil].! !

!DBusConnection methodsFor: 'arguments-write' stamp: 'bf 5/25/2007 20:56'!
writeArgument: arg
	^self perform: (Writers at: arg dbusType) with: arg
! !

Object subclass: #DBusMessage
	instanceVariableNames: 'typeCode path interface member sender destination arguments serial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBus-Core'!

!DBusMessage commentStamp: 'jaf 5/26/2007 20:32' prior: 0!
I am the super class for messages which can send exchanged over a DBusConnection. For an example look at DBusMessage testMethodCall.

This class is known to the DBus plugin. You must not change the order of instance variables.
!

DBusMessage subclass: #DBusMessageError
	instanceVariableNames: 'name replySerial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBus-Core'!

!DBusMessageError class methodsFor: 'constants' stamp: 'jaf 4/27/2007 17:54'!
dbusErrorInvalidArgs
	^ 'org.freedesktop.DBus.Error.InvalidArgs'! !

!DBusMessageError class methodsFor: 'constants' stamp: 'jaf 4/27/2007 18:03'!
dbusErrorUnknownMethod
	^ 'org.freedesktop.DBus.Error.UnknownMethod'! !

!DBusMessageError class methodsFor: 'constants' stamp: 'bf 5/1/2008 19:21'!
dbusErrorUnknownObject
	^ 'org.freedesktop.DBus.Error.UnknownObject'! !

!DBusMessageError class methodsFor: 'instance creation' stamp: 'jaf 5/31/2007 22:42'!
newFor: msg name: aName withMessage: aMessage

	| e |
	msg ifNotNil: [
		(msg isMethodCall) ifFalse: [self error:'Errors are only for a method call which require a reply.'. ^ nil].
		e :=  DBusMessageError new.
		e serial: msg serial;
		  destination: msg sender.
		e name: aName; message: aMessage.
		^ e].
	^ nil 
	
	
	
	! !

!DBusMessageError class methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:53'!
typeCode
	^3! !

!DBusMessageError class methodsFor: 'instance creation' stamp: 'jaf 5/26/2007 20:17'!
unknownMethod: msg

	^ self newFor: msg name: (self dbusErrorUnknownMethod) withMessage: ''.! !

!DBusMessageError methodsFor: 'initialize-release' stamp: 'bf 5/15/2007 15:08'!
initialize
	super initialize.
	name := ''.
	! !

!DBusMessageError methodsFor: 'testing' stamp: 'jaf 4/19/2007 15:26'!
isError
	^true! !

!DBusMessageError methodsFor: 'testing' stamp: 'bf 7/24/2007 22:08'!
isReplyOrError
	^true! !

!DBusMessageError methodsFor: 'accessing' stamp: 'bf 6/10/2008 18:31'!
message
	^arguments first fromDBusArgument! !

!DBusMessageError methodsFor: 'accessing' stamp: 'jaf 4/27/2007 18:24'!
message: m

	self removeAllArguments.
	self addArgument: m.! !

!DBusMessageError methodsFor: 'accessing' stamp: 'jaf 4/27/2007 17:40'!
name
	^ name! !

!DBusMessageError methodsFor: 'accessing' stamp: 'jaf 4/27/2007 17:41'!
name: e
	name := e! !

!DBusMessageError methodsFor: 'testing' stamp: 'jaf 4/27/2007 18:05'!
printOn: aStream
	
	aStream
		nextPutAll: self class name;
		nextPut:  $[;
		print: self name;
		nextPut:  $(;
		print: self message;
		nextPut:  $);
		nextPut: $]! !

!DBusMessageError methodsFor: 'read writing' stamp: 'bf 7/24/2007 22:06'!
readFromConnection: con
	super readFromConnection: con.
	name := con errorName.	
	replySerial :=  con messageReplySerial.	
	! !

!DBusMessageError methodsFor: 'accessing' stamp: 'bf 7/24/2007 22:07'!
replySerial
	^replySerial! !

DBusMessage subclass: #DBusMessageMethodCall
	instanceVariableNames: 'reply'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBus-Core'!

!DBusMessageMethodCall class methodsFor: 'instance creation' stamp: 'bf 6/19/2008 01:11'!
destination: d path: p interface: i member: t

	^ self destination: d path: p  interface: i  member: t reply: true ! !

!DBusMessageMethodCall class methodsFor: 'instance creation' stamp: 'bf 6/19/2008 12:05'!
destination: d path: p interface: i member: t reply: b

	| msg |
	msg := self new.
	msg destination: d ; path: p ; interface: i ; member: t; reply: b.
	^msg! !

!DBusMessageMethodCall class methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:53'!
typeCode
	^1! !

!DBusMessageMethodCall methodsFor: 'initialize-release' stamp: 'bf 2/26/2008 12:01'!
initialize
	super initialize.
	reply := true.
	! !

!DBusMessageMethodCall methodsFor: 'testing' stamp: 'jaf 4/19/2007 15:26'!
isMethodCall
	^true! !

!DBusMessageMethodCall methodsFor: 'read writing' stamp: 'bf 3/5/2008 17:28'!
readFromConnection: con

	super readFromConnection: con.
	reply := con messageNoReply not.! !

!DBusMessageMethodCall methodsFor: 'accessing' stamp: 'jaf 4/27/2007 10:53'!
reply

	^reply! !

!DBusMessageMethodCall methodsFor: 'accessing' stamp: 'jaf 4/27/2007 10:54'!
reply: bool
	reply := bool.
	! !

DBusMessage subclass: #DBusMessageMethodReply
	instanceVariableNames: 'replySerial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBus-Core'!

!DBusMessageMethodReply class methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:53'!
typeCode
	^2! !

!DBusMessageMethodReply methodsFor: 'testing' stamp: 'jaf 4/27/2007 10:57'!
isMethodReply
	^ true! !

!DBusMessageMethodReply methodsFor: 'testing' stamp: 'bf 7/24/2007 22:08'!
isReplyOrError
	^true! !

!DBusMessageMethodReply methodsFor: 'printing' stamp: 'jaf 5/3/2007 14:38'!
printOn: aStream	
	super printOn: aStream.
	aStream
		space; 
		nextPutAll: 'to ';
		nextPut: $(.
	self replySerial printOn: aStream.
	aStream nextPut: $).
	
	! !

!DBusMessageMethodReply methodsFor: 'read writing' stamp: 'jaf 5/3/2007 14:11'!
readFromConnection: con

	super readFromConnection: con.	
	
	"read replyserial"
	replySerial :=  con messageReplySerial.	
	! !

!DBusMessageMethodReply methodsFor: 'accessing' stamp: 'jaf 5/3/2007 14:10'!
replySerial
	^ replySerial! !

DBusMessage subclass: #DBusMessageSignal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBus-Core'!

!DBusMessageSignal class methodsFor: 'class initialization' stamp: 'bf 6/19/2008 12:05'!
path: p interface: i name: t

	| msg |
	msg := self new.
	msg path: p ; interface: i ; member: t.
	^msg! !

!DBusMessageSignal class methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:53'!
typeCode
	^4! !

!DBusMessageSignal methodsFor: 'testing' stamp: 'jaf 4/19/2007 15:27'!
isSignal
	^true! !

!DBusMessage class methodsFor: 'instance creation' stamp: 'bf 7/17/2007 11:17'!
newReplyFor: msg

	| reply |
	(msg isMethodCall and: [msg reply]) ifFalse: [
		^self error: 'You can only create a reply for message which require it.'].
	reply :=  DBusMessageMethodReply new.
	reply serial: msg serial.
	reply destination: msg sender.
	^ reply
! !

!DBusMessage class methodsFor: 'examples' stamp: 'bf 6/19/2008 01:12'!
testMethodCall

	"create a new method call"
	| msg |
	msg := DBusMessageMethodCall destination: 'org.squeak.dbus.example' 
								path: '/org/squeak/dbus/example' 
								interface: 'org.squeak.dbus.testinterface' 
								member: 'testmember'.
	"add some arguments"							
	msg addArgument: (DBusArgument boolean: false). "boolean"	
	msg addArgument: (DBusArgument int32: 125487). "integer 32"
	msg addArgument: (DBusArgument array: {'element 0'. 'element 1'. 'element 2'} signature: 'as'). "3 element array of strings"
	msg addArgument: (DBusArgument variant: (DBusArgument uint64: 45879245651)). "variant with an unsigned integer 64"
		
	^msg		
								! !

!DBusMessage class methodsFor: 'examples' stamp: 'jaf 5/26/2007 20:15'!
testSignal

	"create a new signal"
	| signal |
	signal := DBusMessageSignal path: '/org/squeak/dbus/example' 
								interface: 'org.squeak.dbus.testinterface' 
								name: 'signalname'.
	"add some arguments"							
	signal addArgument: 'test a signal'. "for some basic types this works to"
	
	
	^signal		
								! !

!DBusMessage class methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:52'!
type
	^self typeStrings at: self typeCode ifAbsent: [nil]! !

!DBusMessage class methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:53'!
typeCode
	^0! !

!DBusMessage class methodsFor: 'instance creation' stamp: 'bf 6/19/2008 01:56'!
typeCode: anInteger
	^(self subclasses detect: [:each | each typeCode = anInteger]) new
! !

!DBusMessage class methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:44'!
typeStrings
	^#('method_call' 'method_return'  'error' 'signal')! !

!DBusMessage methodsFor: 'arguments' stamp: 'bf 5/25/2007 20:42'!
addArgument: a 
	arguments add: a asDBusArgument
		! !

!DBusMessage methodsFor: 'arguments' stamp: 'bf 5/25/2007 17:43'!
addArgument: a signature: s
	arguments add: (DBusArgument value: a signature: s)! !

!DBusMessage methodsFor: 'arguments' stamp: 'jaf 5/26/2007 22:42'!
addArgument: a type: s
	arguments add: (DBusArgument value: a type: s)! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 6/12/2008 16:22'!
arguments

	^arguments asArray! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 2/26/2008 11:38'!
arguments: argumentArray

	arguments := argumentArray! !

!DBusMessage methodsFor: 'accessing' stamp: 'jaf 4/19/2007 15:18'!
destination
	^destination! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 2/26/2008 11:39'!
destination: destinationString
	destination := destinationString! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:22'!
fullSelector
	^interface
		ifNil: [member]
		ifNotNil: [interface, '.', member]! !

!DBusMessage methodsFor: 'testing' stamp: 'jf 5/21/2007 21:46'!
hasArguments

	^ (arguments size > 0)! !

!DBusMessage methodsFor: 'initialize-release' stamp: 'bf 6/19/2008 01:54'!
initialize

	path := ''.
	interface := nil.
	sender := ''.
	member := ''.
	destination := ''.
	arguments := OrderedCollection new.
	typeCode := self class typeCode.
	serial := 0.
	
	! !

!DBusMessage methodsFor: 'accessing' stamp: 'jaf 4/19/2007 15:17'!
interface
	^interface! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 2/26/2008 11:38'!
interface: interfaceOrNil
	interface := interfaceOrNil
! !

!DBusMessage methodsFor: 'testing' stamp: 'jaf 4/19/2007 15:25'!
isError
	^false! !

!DBusMessage methodsFor: 'testing' stamp: 'jaf 4/19/2007 15:25'!
isMethodCall
	^false! !

!DBusMessage methodsFor: 'testing' stamp: 'jaf 4/27/2007 10:56'!
isMethodReply
	^false! !

!DBusMessage methodsFor: 'testing' stamp: 'bf 7/24/2007 22:08'!
isReplyOrError
	^false! !

!DBusMessage methodsFor: 'testing' stamp: 'jaf 4/19/2007 15:25'!
isSignal
	^false! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:22'!
member
	^member! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:22'!
member: memberString
	member := memberString! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 6/19/2008 12:03'!
path
	^path! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 6/19/2008 12:04'!
path: pathString
	path := pathString
! !

!DBusMessage methodsFor: 'printing' stamp: 'jaf 4/26/2007 17:16'!
printArgumentsOn: aStream

	aStream nextPut: $(.
	arguments ifNotNil: [
		arguments
			do: [:each | each printOn: aStream]
			separatedBy: [aStream nextPutAll: ', ']].
	aStream nextPut: $).
! !

!DBusMessage methodsFor: 'printing' stamp: 'bf 6/19/2008 12:04'!
printOn: aStream	

	aStream nextPutAll: self class name.
	(self serial > 0) 
		ifTrue: [
			aStream nextPut: $(.
			self serial printOn: aStream.
			aStream nextPut: $).			
		].
	aStream nextPut: $[;
		nextPutAll: (self path ifNil: ['?']);
		space;
		nextPutAll: (self fullSelector ifNil: ['?']).
	self printArgumentsOn: aStream.	
	aStream nextPut: $]
	! !

!DBusMessage methodsFor: 'read writing' stamp: 'jf 5/21/2007 15:51'!
readArgumentsFrom: conn

	| hasArg |
	arguments := OrderedCollection new.
	hasArg := conn messageHasArguments.	
	[hasArg] 
		whileTrue: [
			arguments add: conn getArgument.
			hasArg := conn nextIterator.
		]! !

!DBusMessage methodsFor: 'read writing' stamp: 'bf 6/19/2008 12:04'!
readFromConnection: conn
	self path: conn messagePath.
	self sender: conn messageSender.
	self interface: conn messageInterface.
	self member: conn messageMember.
	self serial: conn messageSerial.
	self readArgumentsFrom: conn
	
	
	
	
	
	! !

!DBusMessage methodsFor: 'arguments' stamp: 'jaf 4/27/2007 18:23'!
removeAllArguments

	arguments := OrderedCollection new! !

!DBusMessage methodsFor: 'accessing' stamp: 'jaf 4/27/2007 11:32'!
reply

	^false! !

!DBusMessage methodsFor: 'accessing' stamp: 'jaf 4/19/2007 15:17'!
sender
	^sender! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 2/26/2008 11:42'!
sender: senderString
	sender := senderString! !

!DBusMessage methodsFor: 'read writing' stamp: 'jf 5/21/2007 21:39'!
sendTo: conn

	conn sendMessage: self.

	

	
	
	! !

!DBusMessage methodsFor: 'accessing' stamp: 'jaf 4/27/2007 10:00'!
serial
	^ serial! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 2/26/2008 11:43'!
serial: serialNumber
	serial := serialNumber! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 2/26/2008 11:43'!
signature
	"answer the full signature of the arguments"
	
	^String streamContents: [:strm |
		arguments do: [:ea | ea printSignatureOn: strm]].
! !

!DBusMessage methodsFor: 'accessing' stamp: 'bf 6/19/2008 01:54'!
type
	^self class typeStrings at: typeCode ifAbsent: [nil]! !

!Object methodsFor: '*DBus-Core' stamp: 'bf 5/25/2007 20:44'!
asDBusArgument
	^ DBusArgument value: self type: self dbusType! !

!Object methodsFor: '*DBus-Core' stamp: 'bf 6/17/2008 16:04'!
asDBusArgumentSignature: aSignature
	^ DBusArgument value: self signature: aSignature! !

!Object methodsFor: '*DBus-Core' stamp: 'bf 5/25/2007 20:44'!
asDBusArgument: type
	^ DBusArgument value: self type: type! !

!Object methodsFor: '*DBus-Core' stamp: 'bf 6/18/2008 16:37'!
dbusCoerceTo: type
	^ self! !

!Object methodsFor: '*DBus-Core' stamp: 'bf 5/25/2007 20:12'!
dbusType
	^self error: self class name, ' has no default dbus type'! !

!Number methodsFor: '*DBus-Core' stamp: 'bf 6/18/2008 16:38'!
dbusCoerceTo: type
	^(type = DBusArgument double)
		ifTrue: [self asFloat]
		ifFalse: [self asInteger]! !

!Dictionary methodsFor: '*DBus-Core' stamp: 'bf 5/25/2007 20:09'!
asDBusArgument
	^ DBusArgument array: self associations
! !

!LargePositiveInteger methodsFor: '*DBus-Core' stamp: 'bf 8/26/2008 16:42'!
dbusType
	"This is too convenient to omit, even though it's technically wrong ..."
	^DBusArgument int64! !

!Float methodsFor: '*DBus-Core' stamp: 'bf 5/25/2007 20:12'!
dbusType
	^ DBusArgument double! !

!Collection methodsFor: '*DBus-Core' stamp: 'bf 5/25/2007 20:11'!
dbusType
	^DBusArgument array! !

!Association methodsFor: '*DBus-Core' stamp: 'bf 5/25/2007 20:07'!
dbusType
	^ DBusArgument dictEntry! !

!WideSymbol methodsFor: '*DBus-Core' stamp: 'bf 9/5/2008 12:14'!
dbusCoerceTo: type
	^self squeakToUtf8 dbusCoerceTo: type
! !

!WideString methodsFor: '*DBus-Core' stamp: 'bf 9/5/2008 12:14'!
dbusCoerceTo: type
	^self squeakToUtf8 dbusCoerceTo: type
! !

!String methodsFor: '*DBus-Core' stamp: 'bf 9/5/2008 12:18'!
dbusCoerceTo: type
	^(type = DBusArgument array)
		ifTrue: [self asByteArray]
		ifFalse: [self]! !

!String methodsFor: '*DBus-Core' stamp: 'bf 5/25/2007 20:10'!
dbusType
	^ DBusArgument string! !

!Boolean methodsFor: '*DBus-Core' stamp: 'bf 3/27/2008 14:35'!
dbusType
	^ DBusArgument boolean! !
DBusConnection initialize!
